#include <iostream>
#include<stdio.h>

using namespace std;
long long a[510000],b[510000];

int uporedi(long long a[510000],long long n,long long k,long long b[510000] )
{
    long long j=0;
    long long c=0,x,d;
    while(k>0)
    {
        x=1;
        d=1;

        while(k>=x )
        {

            if(a[j]>a[x+j])
            {
                j=j+x;
                k=k-x;
                d=0;

            }

            else{
                x++;
            }
        }
        if(d==1)
        {
            b[c]=a[j];
            c++;
            j++;
        }

    }
    while(c<n-k)
    {
        b[c]=a[j];
        c++;
        j++;
    }
}
int main()
{
    long long n,k,i,j,t;
    cin>>n;
    cin>>k;
    for(i=0;i<n;i++)
    {
       /* cin>>a[i];*/
        scanf("%ld",&a[i]);
    }
    uporedi(a,n,k,b);
    for(i=0;i<n-k;i++)
    {
        /*cout<<b[i];*/
        printf("%ld",b[i]);
        printf(" ");

    }


    return 0;
}